package io.github.lonamiwebs.overgram;

import io.github.lonamiwebs.overgram.generator.Generator;
import io.github.lonamiwebs.overgram.parser.TLObject;
import io.github.lonamiwebs.overgram.parser.TLReader;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Overgram {
    public static void main(final String... args) throws IOException {
        final Map<String, List<TLObject>> objects = new HashMap<>();
        for (int i = 1; i < args.length; ++i) {
            TLReader.readTlObjects(objects, new File(args[i]));
        }

        final File parent = new File(args[0]);
        Generator.generateJava(
                objects.get("types"),
                objects.get("functions"),
                new File(parent, "Abstract.java"),
                new File(parent, "Types.java"),
                new File(parent, "Functions.java")
        );
    }
}
